package com.nokia.domainb.capability;

import cn.chinaunicom.open.nlgxptconnection.COMPConnectionContext;
import com.google.gson.JsonObject;
import com.google.gson.JsonParser;
import com.nokia.domainb.capability.entity.Route;
import com.nokia.domainb.util.Utils;
import de.siegmar.fastcsv.writer.CsvWriter;
import org.junit.jupiter.api.Test;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.time.LocalDateTime;
import java.util.Set;

public class QryRouteAllTest {
    @Test
    void testQuery() {
        QryRouteAll qryRouteAll = new QryRouteAll();
        //        Set<String> phones = Collections.singleton("13739798862");
        Set<String> phones = Utils.readPhones();
        String phonesPath = "phones.txt";
        String filePath = "result/路由查询.csv";
        try (BufferedWriter bufferedWriter = new BufferedWriter(new FileWriter(phonesPath));
             OutputStreamWriter osw = new OutputStreamWriter(Files.newOutputStream(Paths.get(filePath)), "GBK");
             CsvWriter csv = CsvWriter.builder().build(osw);) {
            csv.writeRow("手机号", "时间", "调用时长", "结果");
            for (String t : phones) {
                LocalDateTime startTime = LocalDateTime.now();
                long startTimestamp = System.currentTimeMillis();
                String result = qryRouteAll.query(t);
                long endTimestamp = System.currentTimeMillis();
                long cost = endTimestamp - startTimestamp;
                csv.writeRow(t, startTime.toString(), String.valueOf(cost), result);
                JsonObject jsonObject = JsonParser.parseString(result).getAsJsonObject();
                String userStatus = jsonObject.getAsJsonObject("UNI_BSS_BODY")
                        .getAsJsonObject("QRYROUTEALL_RSP")
                        .getAsJsonObject("RSP")
                        .getAsJsonArray("DATA")
                        .get(0)
                        .getAsJsonObject()
                        .get("USER_STATUS")
                        .getAsString();
                boolean invalidPhone = !(userStatus.equals("1") || userStatus.equals("2"));
                if (invalidPhone) {
                    continue;
                }

                try {
                    bufferedWriter.write(t + "\n");
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    @Test
    void testQueryWithSdk() {
        QryRouteAll qryRouteAll = new QryRouteAll();
        COMPConnectionContext result = qryRouteAll.queryWithSdk("13739798862");
        System.out.println(result.getResponseContext());
    }

    @Test
    void testQuery2() {
        QryRouteAll qryRouteAll = new QryRouteAll();
        Route result = qryRouteAll.query2("13231899751", false);
        System.out.println(result);
    }

    @Test
    void testQuery22() {
        QryRouteAll qryRouteAll = new QryRouteAll();
        Route result = qryRouteAll.query2("13739798862", false);
        System.out.println(result);
    }
}
